; main.s

	GET	macros.s

SMALL_SIZE	*	2048				; Size of chunk allocated to small rmallocs

	AREA	|____main_init|, CODE, READONLY
	EXPORT	main_init
main_init

	MOV	r2,r0
	LDR	r3,=|__main_taskname|
mi_copyname
	LDRB	r1,[r0],#1
	STRB	r1,[r3],#1
	CMP	r1,#32
	BGE	mi_copyname
	MOV	r1,#0
	STRB	r1,[r3,#-1]
	MOV	r0,#200
	LDR	r1,TASK
	SWI	XWimp_Initialise
	IMPORT	exit
	BVS	exit					; Can't handle it!
	LDR	r3,=|__main_task|
	STR	r1,[r3]
	STR	r0,[r3,#-4]
	IMPORT	|_draw_getmode|
	IMPORT	|_draw_getpalette|
;	IMPORT	|_get_3dstatus|
	STMFD	r13!,{lr}
	BL	|_get_3dstatus|
	BL	|_draw_getpalette|
	LDR	r0,=rmalloc_handler
	LDR	r1,=R__Malloc
	LDR	r2,=R__Calloc
	LDR	r3,=R__Free
	STMIA	r0,{r1-r3}				; This is naughty!!!
	LDMFD	r13!,{lr}
	B	|_draw_getmode|

TASK	=	"TASK"

	LTORG

	AREA	|____main_initnormalloc|, CODE, READONLY
	EXPORT	main_initnormalloc
main_initnormalloc

	MOV	r2,r0
	LDR	r3,=|__main_taskname|
mi2_copyname
	LDRB	r1,[r0],#1
	STRB	r1,[r3],#1
	CMP	r1,#32
	BGE	mi2_copyname
	MOV	r1,#0
	STRB	r1,[r3,#-1]
	MOV	r0,#200
	LDR	r1,TASK2
	SWI	XWimp_Initialise
	BVS	exit					; Can't handle it!
	LDR	r3,=|__main_task|
	STR	r1,[r3]
	STR	r0,[r3,#-4]
	STMFD	r13!,{lr}
	BL	|_draw_getpalette|
	BL	|_get_3dstatus|
	LDMFD	r13!,{lr}
	B	|_draw_getmode|

TASK2	=	"TASK"

	LTORG

	AREA	|____main_nextnull|, CODE, READONLY
	EXPORT	main_nextnull
main_nextnull

	LDR	r1,=|_next_polltime|
	STR	r0,[r1]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	LTORG

	AREA	|____main_time|, CODE, READONLY
	EXPORT	main_time
main_time

	SWI	XOS_ReadMonotonicTime
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|_main_data|, COMMON, NOINIT
        EXPORT  main_wimpversion
|__main_wimpversion|
main_wimpversion
	DCD	0

        EXPORT  main_taskhandle
|__main_task|
main_taskhandle
	DCD	0
	EXPORT	|__main_taskname|
	EXPORT	TASKNAME
TASKNAME
|__main_taskname|
	%	32
|__main_bottom_rmalloc|
	DCD	0					; Bottom of allocated memory
|__main_top_rmalloc|
	DCD	0					; Top of allocated memory
|__main_first_small|
	DCD	0					; First small allocation
	EXPORT	|_next_polltime|
|_next_polltime|
	DCD	0
null_handler
	DCD	0
redraw_handler
	DCD	0
open_handler
	DCD	0
close_handler
	DCD	0
enter_handler
	DCD	0
leave_handler
	DCD	0
mouse_handler
	DCD	0
drag_handler
	DCD	0
key_handler
	DCD	0
menu_handler
	DCD	0
scroll_handler
	DCD	0
lose_handler
	DCD	0
gain_handler
	DCD	0

message_handler
	DCD	0
messageack_handler
	DCD	0
acknowledge_handler
	DCD	0

save_handler
	DCD	0
saveack_handler
	DCD	0
load_handler
	DCD	0
loadack_handler
	DCD	0
run_handler
	DCD	0

help_handler
	DCD	0
mode_handler
	DCD	0
palette_handler
	DCD	0
prequit_handler
	DCD	0
menuwarn_handler
	DCD	0
immediate_handler
	DCD	0
rmalloc_handler
	DCD	0
rcalloc_handler
	DCD	0
rfree_handler
	DCD	0

clipclaim_handler
	DCD	0
cliprequest_handler
	DCD	0
dragging_handler
	DCD	0
dragclaim_handler
	DCD	0
ramfetch_handler
	DCD	0
ramtransmit_handler
	DCD	0

device_claimhandler
	DCD	0
device_unclaimedhandler
	DCD	0
device_claimedhandler
	DCD	0

taskexit_handler
	DCD	0

temp_regs
	%	20

pollword
	DCD	0

	AREA	R__Malloc, CODE, READONLY

	ADD	r0,r0,#3
	BIC	r0,r0,#3				; Word-align size
	STMFD	r13!,{r0-r6,r14}
	CMP	r0,#256
	BLT	rm_small				; A small (<256) byte allocation
	LDR	r2,=|__main_bottom_rmalloc|
	LDR	r3,[r2]
	TEQ	r3,#0
	BLEQ	|__create_rmalloc|			; r3 is now bottom of allocated memory
	TEQ	r3,#0
	BEQ	rm_fail					; Couldn't create start block
	LDR	r2,=|__main_top_rmalloc|
	LDR	r2,[r2]					; r2 is now top of allocated memory
	LDR	r1,RMFREE
rm_findloop
	LDMIA	r3,{r4,r5}				; Read type, size
	TEQ	r4,r1
	BNE	rm_findnext
	CMP	r5,r0					; Is the size large enough?
	BGE	rm_found
rm_findnext
	MOV	r6,r3
	ADD	r3,r3,#8
	ADD	r3,r3,r5
	TEQ	r3,r2
	BNE	rm_findloop				; Right, if we reach the top, allocate some more
	TEQ	r4,r1
	SUBEQ	r5,r0,r5				; Subtract how much we need
	ADDNE	r5,r0,#12				; Or, if last block isn't FREE then it's the lot!
	MOVNE	r6,r2					; This is our FREE block
	MOV	r4,r2
	MOV	r0,#-1
	MOV	r1,#-1
	STMFD	r13!,{r4}
	SWI	XWimp_SlotSize
	LDMFD	r13!,{r4}
	CMP	r5,r2					; Can we get enough?
	BGE	rm_fail
	ADD	r0,r5,r4				; Add on the top of memory
	SUB	r0,r0,#&8000				; Don't forget it's SIZE, not LOCATION
	MOV	r1,#-1
	STMFD	r13!,{r4}
	SWI	XWimp_SlotSize				; Claim the memory
	LDMFD	r13!,{r4}
	ADD	r2,r0,#&8000				; Make it a location
	LDR	r1,=|__main_top_rmalloc|
	STR	r2,[r1]
	LDR	r1,RMFREE
	SUB	r2,r2,r6				; r6 was the old memory location
	SUB	r5,r2,#8
	STMIA	r6,{r1,r5}				; Store FREE and new size
;	STR	r5,[r6,#4]				; Store new size
	MOV	r3,r6					; Reset the pointer
	LDR	r0,[r13]				; Reread the size
	LDR	r2,=|__main_top_rmalloc|
	LDR	r2,[r2]
	B	rm_findloop
rm_fail	MOV	r0,#0
	STR	r0,[r13]
 [ arm32
	LDMFD	r13!,{r0-r6,pc}
 |
	LDMFD	r13!,{r0-r6,pc}^
 ]
rm_found
	SUB	r5,r5,r0
	CMP	r5,#12
	BLT	rm_allocate
	STR	r0,[r3,#4]				; Set size
	ADD	r2,r3,r0
	ADD	r2,r2,#8
	SUB	r5,r5,#8				; 8 byte header
	LDR	r1,RMFREE
	STR	r1,[r2]
	STR	r5,[r2,#4]				; Store RMFR, SIZE
rm_allocate
	LDR	r1,RMLRGE
	STR	r1,[r3]					; Store RMLG
	ADD	r0,r3,#8
	STR	r0,[r13]
 [ arm32
	LDMFD	r13!,{r0-r6,pc}			; And return
 |
	LDMFD	r13!,{r0-r6,pc}^			; And return
 ]
rm_small
	LDR	r1,=|__main_first_small|
	LDR	r2,[r1]
rm_findloop_s
	TEQ	r2,#0
	BNE	rm_noalloc_s
	MOV	r0,#SMALL_SIZE
	BL	R__Malloc					; Find a large heap
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r6,pc}			; Exit if we can't allocate a block
 |
	LDMEQFD	r13!,{r0-r6,pc}^			; Exit if we can't allocate a block
 ]
	MOV	r2,r0
	STR	r2,[r1]					; Store in last pointer
	MOV	r0,#0
	STR	r0,[r2]					; Store 'next' pointer
	LDR	r0,RMFREE
	STR	r0,[r2,#4]				; Store 'RMFR'
	MOV	r0,#2048
	SUB	r0,r0,#12
	STR	r0,[r2,#8]				; Store size of free block
	LDR	r0,[r13]				; Reread size
rm_noalloc_s
	LDR	r3,RMFREE
	ADD	r6,r2,#4
	MOV	r1,r2
	ADD	r2,r2,#2048				; Point to end
rm_findloop2_s
	LDMIA	r6,{r4,r5}
	TEQ	r4,r3
	BNE	rm_findnext_s
	CMP	r5,r0
	BGE	rm_found_s
rm_findnext_s
	ADD	r6,r6,r5
	ADD	r6,r6,#8
	CMP	r6,r2
	BLT	rm_findloop2_s
	LDR	r2,[r1]
	B	rm_findloop_s				; Find it in the next chain
rm_found_s
	SUB	r3,r5,r0
	CMP	r3,#12
	BLT	rm_allocate_s
	STR	r0,[r6,#4]				; Set size
	ADD	r4,r6,r0
	ADD	r4,r4,#8				; Point to next block
	SUB	r3,r3,#8
	STR	r3,[r4,#4]				; Set next block's size
	LDR	r3,RMFREE
	STR	r3,[r4]					; Set a pointer
rm_allocate_s
	LDR	r3,RMSMLL
	STR	r3,[r6]
	ADD	r0,r6,#8				; Point to the block
	STR	r0,[r13]
 [ arm32
	LDMFD	r13!,{r0-r6,pc}			; And return
 |
	LDMFD	r13!,{r0-r6,pc}^			; And return
 ]

|__create_rmalloc|
; r0 is size to initially create
	STMFD	r13!,{r0-r2,r4,lr}
	MOV	r4,r0
	MOV	r0,#-1
	MOV	r1,#-1
	STMFD	r13!,{r4}
	SWI	XWimp_SlotSize
	LDMFD	r13!,{r4}
	CMP	r2,r4					; Is the memory to allocate it?
	MOVLE	r3,#0
 [ arm32
	LDMLEFD	r13!,{r0-r2,r4,pc}
 |
	LDMLEFD	r13!,{r0-r2,r4,pc}^
 ]
	ADD	r3,r0,#&8000
	ADD	r0,r0,r4				; Find the new size
	LDR	r4,=|__main_bottom_rmalloc|
	STR	r3,[r4]					; Store in bottom
	MOV	r1,#-1
	STMFD	r13!,{r4}
	SWI	XWimp_SlotSize
	LDMFD	r13!,{r4}
	ADD	r2,r0,#&8000				; Point to new top
	STR	r2,[r4,#4]				; And top
	LDR	r1,RMFREE
	STR	r1,[r3]
	LDR	r3,[r4]
	SUB	r0,r2,r3				; Get the size
	SUB	r0,r0,#8
	STR	r0,[r3,#4]				; Store it
 [ arm32
	LDMFD	r13!,{r0-r2,r4,pc}
 |
	LDMFD	r13!,{r0-r2,r4,pc}^
 ]

RMFREE	=	"FREE"
RMLRGE	=	"LRGE"
RMSMLL	=	"SMLL"

	LTORG

	AREA	R__Calloc, CODE, READONLY

	MUL	r0,r1,r0
	B	rmalloc

	AREA	R__Free, CODE, READONLY

	STMFD	r13!,{r4-r9,lr}
rf_free
	LDR	r1,[r0,#-8]				; Get type
	LDR	r3,RFLRGE
	TEQ	r3,r1
	BEQ	rf_large				; Free a large block
	LDR	r9,=|__main_first_small|
	LDR	r3,[r9]					; Get pointer to first small chunk
rf_findloop_s
	ADD	r4,r3,#SMALL_SIZE
	CMP	r0,r3
	BLT	rf_findnext_s				; Too high...
	CMP	r0,r4
	BLT	rf_found_s				; Found the block (block
rf_findnext_s
	MOV	r9,r3					; Set pointer to last small chunk
	LDR	r5,[r3]					; Get pointer to next small chunk
	MOVS	r3,r5
	BEQ	rf_failed
	B	rf_findloop_s
rf_found_s						; It's in this chunk
	ADD	r5,r3,#4				; Point to first one
	LDR	r7,RFFREE
	MOV	r8,#0
rf_findloop2_s
	ADD	r6,r5,#8
	TEQ	r6,r0					; Is it this one?
	BEQ	rf_found2_s
	LDR	r4,[r5]
	TEQ	r4,r7
	MOVEQ	r8,r5
	MOVNE	r8,#0
	LDR	r4,[r5,#4]
	ADD	r5,r6,r4
	B	rf_findloop2_s
rf_found2_s
	TEQ	r8,#0
	STREQ	r7,[r5]					; Set the type
	BEQ	rf_join_s
	LDR	r6,[r5,#4]
	LDR	r2,[r8,#4]				; Get the other size
	ADD	r2,r2,r6
	ADD	r2,r2,#8
	STR	r2,[r8,#4]				; Add the two together to make a larger free chunk
	MOV	r5,r8
rf_join_s
	LDR	r8,[r5,#4]				; Get type
	ADD	r8,r5,r8
	ADD	r8,r8,#8
	TEQ	r8,r4					; Was it the last allocated chunk?
	BEQ	rf_checkwhole_s
	LDR	r6,[r8]
	TEQ	r6,r7
 [ arm32
	LDMNEFD	r13!,{r4-r9,pc}
 |
	LDMNEFD	r13!,{r4-r9,pc}^
 ]
	LDR	r6,[r8,#4]
	LDR	r2,[r5,#4]
	ADD	r2,r2,r6
	ADD	r2,r2,#8
	STR	r2,[r5,#4]
rf_checkwhole_s
	LDR	r2,[r3,#8]				; Get size of first chunk
	CMP	r2,#SMALL_SIZE-16			; Is the chunk empty?
 [ arm32
	LDMLTFD	r13!,{r4-r9,pc}			; Nope...
 |
	LDMLTFD	r13!,{r4-r9,pc}^			; Nope...
 ]
	LDR	r2,[r3]
	STR	r2,[r9]					; Store next pointer into old pointer (linked list)
	MOV	r0,r3					; Point to small chunk
	B	rf_free					; No need to pop off any parameters...

RFFREE	=	"FREE"
RFLRGE	=	"LRGE"

rf_large
	LDR	r1,=|__main_bottom_rmalloc|
	LDMIA	r1,{r1,r2}				; Get bottom and top pointers
	MOV	r8,#0
	LDR	r7,RFFREE
rf_findloop
	ADD	r3,r1,#8
	TEQ	r3,r0
	BEQ	rf_found
	LDR	r3,[r1]
	TEQ	r3,r7
	MOVEQ	r8,r1
	MOVNE	r8,#0
	LDR	r3,[r1,#4]
	ADD	r1,r1,r3
	ADD	r1,r1,#8				; Get next address
	CMP	r1,r2
	BGE	rf_failed
	B	rf_findloop
rf_found
	TEQ	r8,#0
	STREQ	r7,[r1]
	BEQ	rf_checknext
	LDR	r5,[r1,#4]				; Get this size
	LDR	r6,[r8,#4]				; And the last one
	ADD	r5,r5,r6
	ADD	r5,r5,#8
	STR	r5,[r8,#4]
	MOV	r1,r8					; Fake the pointer
rf_checknext
	LDR	r5,[r1,#4]
	ADD	r4,r5,r1
	ADD	r4,r4,#8
	TEQ	r4,r2
	BEQ	rf_checkend
	LDR	r5,[r4]
	TEQ	r5,r7
 [ arm32
	LDMNEFD	r13!,{r4-r9,pc}			; Next chunk isn't a FREE
 |
	LDMNEFD	r13!,{r4-r9,pc}^			; Next chunk isn't a FREE
 ]
	LDR	r5,[r1,#4]
	LDR	r6,[r4,#4]
	ADD	r5,r5,r6
	ADD	r5,r5,#8
	STR	r5,[r1,#4]
	B	rf_checknext				; Try the next chunk as well...
rf_checkend
	MOV	r3,r1
	SUB	r0,r1,#&8000				; Get a size (remove some memory)
	ADD	r0,r0,#12				; Add some more, in case of problems
	MOV	r1,#-1
	SWI	XWimp_SlotSize
	ADD	r2,r0,#&8000				; Get the new size
	LDR	r4,=|__main_top_rmalloc|
	STR	r2,[r4]					; Store the new top of memory
	SUB	r2,r2,r3				; Get last pointer
	SUB	r2,r2,#8				; Don't forget the header
	STR	r2,[r3,#4]				; Store the size
rf_failed
 [ arm32
	LDMFD	r13!,{r4-r9,pc}			; Exit...
 |
	LDMFD	r13!,{r4-r9,pc}^			; Exit...
 ]

;rf_failed
 [ arm32
;	LDMFD	r13!,{r4-r9,pc}
 |
;	LDMFD	r13!,{r4-r9,pc}^
 ]

	LTORG

	AREA	|____rmalloc|, CODE, READONLY
	EXPORT	rmalloc
rmalloc

	LDR	r1,=rmalloc_handler
	LDR	r1,[r1]
	TEQ	r1,#0
	MOVEQ	r0,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	MOV	pc,r1

	AREA	|____rcalloc|, CODE, READONLY
	EXPORT	rcalloc
rcalloc

	LDR	r2,=rcalloc_handler
	LDR	r2,[r2]
	TEQ	r2,#0
	MOVEQ	r0,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	MOV	pc,r2

	AREA	|____rfree|, CODE, READONLY
	EXPORT	rfree
rfree

	LDR	r1,=rfree_handler
	LDR	r1,[r1]
	TEQ	r1,#0
	MOVEQ	r0,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	MOV	pc,r1

	AREA	|____main_exit|, CODE, READONLY
	EXPORT	main_exit
main_exit

	SWI	XWimp_CloseDown
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	message_block, COMMON, NOINIT
	EXPORT	poll_lastevent
poll_lastevent
	%	4
	EXPORT	poll_block
poll_block
	%	256

	AREA	|____main_poll|, CODE, READONLY
	EXPORT	main_poll
main_poll

main_pollL
	BL	poll_once
	B	main_pollL

main_poll2
 [ arm32
	LDMFD	r13!,{r4-r9,pc}
 |
	LDMFD	r13!,{r4-r9,pc}^
 ]

	EXPORT	poll_once

poll_once
	STMFD	r13!,{r4-r9,lr}
	LDR	r3,=null_handler
	LDR	r2,[r3,#handler_immediate*4]
	TEQ	r2,#0
	MOVNE	r0,#0
	MOVNE	r2,#0
	BNE	poll_immediate
	LDR	r0,[r3]
	TEQ	r0,#0
	MOVEQ	r0,#1
	MOVEQ	r2,#0
	MOVNE	r0,#0
	LDRNE	r2,[r3,#-4]				; Get next time
	TEQ	r2,#0
	MOVEQ	r0,#1
poll_immediate
	LDR	r3,=pollword
	LDR	r3,[r3]
	TEQ	r3,#0
	ORRNE	r0,r0,#1<<22
	LDR	r1,=poll_block
	TEQ	r2,#0
	SWINE	XWimp_PollIdle
	SWIEQ	XWimp_Poll
	LDR	r3,=null_handler
	STR	r0,[r1,#-4]				; Store in poll_lastevent
	LDR	r2,[r3,#handler_immediate*4]
	TEQ	r2,#0
	BEQ	no_immediate
	STMFD	r13!,{r0-r3}
	MOV	r12,#0
	STR	r12,[r3,#handler_immediate*4]
	MOV	lr,pc
	MOV	pc,r2
	LDMFD	r13!,{r0-r3}
no_immediate
	CMP	r0,#13
	BCS	mp_checkmessage
	LDR	r6,[r3,r0,LSL#2]			; Get message handler
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	B	main_poll2
mp_checkmessage
	TEQ	r0,#17
	BEQ	mp_message
	TEQ	r0,#18
	BEQ	mp_messageack
	TEQ	r0,#19
	BEQ	mp_acknowledge
	B	main_poll2				; Ignore this code...
mp_message
	LDR	r2,[r1,#16]
	TEQ	r2,#0					; Is it exit?
	BNE	mpm_notquit
	LDR	r6,=taskexit_handler
	LDR	r6,[r6]
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	MOV	r0,#0
	B	exit
mpm_notquit
	ADR	r4,messages
mpm_find
	LDMIA	r4!,{r5,r6}
	TEQ	r2,r5
	LDR	r6,[r6]
	BEQ	mpm_found
	TEQ	r5,#0
	BNE	mpm_find
mpm_found
	TEQ	r6,#0
	LDREQ	r6,=message_handler
	LDREQ	r6,[r6]
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	B	main_poll2

messages
	DCD	1,save_handler
	DCD	2,saveack_handler
	DCD	3,load_handler
	DCD	4,loadack_handler
	DCD	5,run_handler
	DCD	&502,help_handler2
	DCD	9,palette_handler2
	DCD	8,prequit_handler
	DCD	&400c0,menuwarn_handler
	DCD	&400c1,fake_modehandler
	DCD	15,clipclaim_handler
	DCD	16,cliprequest_handler
	DCD	17,dragging_handler
	DCD	18,dragclaim_handler
	DCD	6,ramfetch_handler
	DCD	7,ramtransmit_handler
	DCD	11,device_claimhandler
	DCD	12,device_claimedhandler
	DCD	0,message_handler

help_handler2
	DCD	main_helphandler
palette_handler2
	DCD	main_palettehandler
fake_modehandler
	DCD	main_modehandler

main_helphandler
;	ADD	r1,r1,#20
	LDR	r6,=help_handler
	LDR	r6,[r6]
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	B	main_poll2

main_modehandler
	BL	|_draw_getmode|
	LDR	r6,=mode_handler
	LDR	r6,[r6]
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	B	main_poll2

main_palettehandler
	BL	|_draw_getpalette|
	LDR	r6,=palette_handler
	LDR	r6,[r6]
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	B	main_poll2

mp_messageack
	LDR	r2,[r1,#16]
	TEQ	r2,#0					; Is it exit?
	IMPORT	exit
	MOVEQ	r0,#0
	BEQ	exit					; Call the exit handler
	ADR	r4,messages
mpma_find
	LDMIA	r4!,{r5,r6}
	TEQ	r2,r5
	LDREQ	r6,[r6]
	BEQ	mpma_found
	TEQ	r5,#0
	BNE	mpma_find
	LDR	r6,[r6,#4]
mpma_found
	TEQ	r6,#0
	LDREQ	r6,=messageack_handler
	LDREQ	r6,[r6]
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	B	main_poll2

mp_acknowledge
	LDR	r3,[r1,#16]
	TEQ	r3,#11
	BEQ	mp_devunc
mp_uka	LDR	r3,=acknowledge_handler
	LDR	r6,[r3]
	TEQ	r6,#0
	MOVNE	lr,pc
	MOVNE	pc,r6
	B	main_poll2

mp_devunc
	LDR	r3,=device_unclaimedhandler
	LDR	r6,[r3]
	TEQ	r6,#0
	BEQ	mp_uka
	MOV	lr,pc
	MOV	pc,r6
	B	main_poll

	LTORG

	AREA	|____main_addhandler|, CODE, READONLY
	EXPORT	main_addhandler
main_addhandler

; r0 is handler number
; r1 is ^ handler
; returns r0 as ^ old handler
	LDR	r2,=null_handler
	LDR	r3,[r2,r0,LSL#2]				; Read the old one
	CMP	r1,#-1						; -1 means read it...
	STRNE	r1,[r2,r0,LSL#2]				; Store the new
	MOV	r0,r3
 [ arm32
	MOV	pc,lr						; Return...
 |
	MOVS	pc,lr						; Return...
 ]

	LTORG

	AREA	|____main_send|, CODE, READONLY
	EXPORT	main_send
main_send

; r0 is ^ block
; r1 is message number
; r2 is task/window
; r3 is icon (if window=-2)
	EOR	r0,r0,r1
	EOR	r1,r0,r1
	EOR	r0,r0,r1
	SWI	XWimp_SendMessage
	MOV	r0,r2						; Set the destination task...
 [ arm32
	MOV	pc,lr						; Nuffin' to it!!!
 |
	MOVS	pc,lr						; Nuffin' to it!!!
 ]

	AREA	|____main_acknowledge|, CODE, READONLY
	EXPORT	main_acknowledge
main_acknowledge

; r0 is ^ message
; r1 is message number
; r2 is action to respond
	STR	r2,[r0,#16]					; Set the action
	LDR	r2,[r0,#8]
	STR	r2,[r0,#12]					; my_ref=your_ref
	EOR	r0,r0,r1
	EOR	r1,r0,r1
	EOR	r0,r0,r1
	LDR	r2,[r1,#4]
	SWI	XWimp_SendMessage
 [ arm32
	MOV	pc,lr						; Little harder, but still easy...
 |
	MOVS	pc,lr						; Little harder, but still easy...
 ]

	AREA	|____simple_warning|, CODE, READONLY
	EXPORT	simple_warning
simple_warning

; r0 is ^ text
; r1 is 0 for OK, 1 for CANCEL, 2 for both
	ADR	r3,sw_text+4
sw_copytxt
	LDRB	r2,[r0],#1
	STRB	r2,[r3],#1
	CMP	r2,#32
	BGE	sw_copytxt
	MOV	r2,#0
	STRB	r2,[r3,#-1]
	ADR	r0,sw_text
	ADD	r1,r1,#1
	LDR	r2,=|__main_taskname|
	SWI	XWimp_ReportError
	MOV	r0,r1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

sw_text	DCD	0
	%	240

	LTORG

	AREA	|_3dstatus|, COMMON, NOINIT
	%	4

	AREA	|____get_3dstatus|, CODE, READONLY
	EXPORT	get_3dstatus
get_3dstatus

	LDR	r0,=|_3dstatus|
	LDR	r0,[r0]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|VB____get_3dstatus|, CODE, READONLY
	EXPORT	|_get_3dstatus|
|_get_3dstatus|

	STMFD	r13!,{r14}
	BL	g3d
	LDR	r1,=|_3dstatus|
	STR	r0,[r1]
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

g3d
	LDR	r0,=|__main_wimpversion|
	LDR	r0,[r0]
	CMP	r0,#300
	MOVLT	r0,#0
 [ arm32
	MOVLT	pc,lr
 |
	MOVLTS	pc,lr
 ]
	MOV	r0,#161
	MOV	r1,#140
	SWI	XOS_Byte
	AND	r0,r2,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	LTORG

	AREA	|____get_dragstatus|, CODE, READONLY
	EXPORT	get_dragstatus
get_dragstatus

	MOV	r0,#161
	MOV	r1,#28
	SWI	XOS_Byte
	AND	r0,r2,#2
	MOV	r0,r0,LSR#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	error_data, NOINIT
	%	264
in_error
	%	4
old_errordata
	%	12

	AREA	main_crashdata, CODE
error_buffer
	%	256
exception_exception
	DCD	0
exception_errorstring
	=	"While performing an operation, a potentially fatal error occurred. "
	=	"If you click on 'Continue', the program will attempt to continue. "
	=	"Otherwise, click on 'Quit' to quit the program.",0
	ALIGN
	%	64

exception_deal
	ADR	r0,exception_errorstring
	ADR	r1,error_buffer
	MOV	r2,#0
	STR	r2,[r1],#4
exception_copy
	LDRB	r3,[r0],#1
	STRB	r3,[r1],#1
	CMP	r3,#0
	BNE	exception_copy
	ADR	r0,error_buffer
	B	error_handle

w_h	*	440
mid_y	*	32
iw	*	176

 [ arm32
	MOV	pc, lr
 |
	MOVS	pc, lr
 ]

	AREA	errorbox_copyerror, NOINIT
	%	256

	AREA	|____new_errorbox|, CODE
	EXPORT	new_errorbox
new_errorbox

; r0 is ^ error
; r1 is ^ title text
; r2 is ^ sprite name
; r3 is number of boxes
; r13 is ^ list of boxes

	MOV	r12,r13
	STMFD	r13!,{r4-r9,lr}
	LDR	r4,=|_3dstatus|
	LDR	r4,[r4]
	TEQ	r4,#0
	BEQ	neb_skip3d
	STMFD	r13!,{r0-r3}
	BL	errorbox_3d
	LDMFD	r13!,{r0-r3}
neb_skip3d
	IMPORT	draw_maxx
	LDR	r4,old_nulltime
	TEQ	r4,#0
	MOVNE	r0,#0
 [ arm32
	LDMNEFD	r13!,{r4-r9,pc}
 |
	LDMNEFD	r13!,{r4-r9,pc}^
 ]
	LDR	r4,=draw_maxx
	LDMIA	r4,{r4,r5}
	MOV	r4,r4,ASR#1
	MOV	r5,r5,ASR#1
	ADD	r6,r4,#360
	ADD	r7,r5,#w_h/2
	SUB	r4,r4,#360
	SUB	r5,r5,#w_h/2
;	ADD	r0,r0,#4
	STMFD	r13!,{r1-r3,r12}
	ADD	r1,r0,#4
	LDR	r0,=errorbox_copyerror
	MOV	r2,#248
	IMPORT	strncpy
	BL	strncpy
	LDMFD	r13!,{r1-r3,r12}
	STR	r0,errorbox_error
	STR	r1,errorbox_title
	STR	r2,errorbox_sprite
	STR	r3,errorbox_options
	ADD	r1,r3,#4
	STR	r1,errorbox_icons
	ADR	r2,errorbox_ecoords
	ADD	r2,r2,#20
set_icon_loop
	LDR	r0,[r12],#4
	STR	r0,[r2],#32
	SUBS	r3,r3,#1
	BPL	set_icon_loop
	ADR	r1,errorbox_location
	STMIA	r1,{r4-r7}
	LDMIA	r1,{r0-r3}
	ADD	r3,r3,#40
	BL	set_mousewindow
	ADR	r1,errorbox_location
	SWI	XWimp_CreateWindow
	STR	r0,errorbox_window
	STR	r0,errorbox_click
	ADR	r1,errorbox_window
	SWI	XWimp_OpenWindow
RPoll	ADR	r1,errorbox_ig
	MOV	r0,#handler_immediate
	BL	main_addhandler
	MOV	r0,#-1
	STR	r0,old_nulltime
	BL	poll_once
	LDR	r0,old_nulltime
	CMP	r0,#-1
	BEQ	RPoll
	LDR	r2,=draw_maxx
	LDMIA	r2,{r2,r3}
	MOV	r0,#0
	MOV	r1,#0
	BL	set_mousewindow
	LDR	r0,errorbox_chose
 [ arm32
	LDMFD	r13!,{r4-r9,pc}
 |
	LDMFD	r13!,{r4-r9,pc}^
 ]

	LTORG

old_nulltime
	DCD	0
errorbox_options
	DCD	1
errorbox_chose
	DCD	0

errorbox_ig
	TEQ	r0,#0
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	STR	r0,old_nulltime
	STMFD	r13!,{r4-r5,lr}
	B	errorbox_i

errorbox_w
	SWI	XOS_Mouse
	TEQ	r2,#0
	BNE	errorbox_w

errorbox_i
	MOV	r0,#129
	MOV	r1,#0
	MOV	r2,#0
	SWI	XOS_Byte
	TEQ	r2,#0
	BNE	errorbox_nokey
	TEQ	r2,#&1b
	TEQNE	r1,#&1b
	BNE	errorbox_noescape
	MOV	r0,#124
	SWI	XOS_Byte
	LDR	r0,errorbox_options
	ADD	r0,r0,#3
	B	errorbox_chosen
errorbox_noescape
	TEQ	r1,#13
	TEQNE	r1,#10
	MOVEQ	r0,#4
	BEQ	errorbox_chosen
	SUBS	r1,r1,#&81
	BMI	errorbox_nokey
	LDR	r0,errorbox_options
	CMP	r1,r0
	BGE	errorbox_nokey
	ADD	r0,r1,#4
	B	errorbox_chosen
errorbox_nokey
	SWI	XOS_Mouse
	TEQ	r2,#0
	BEQ	errorbox_i
	ADR	r4,errorbox_location
	LDMIA	r4,{r4,r5}
	SUB	r0,r0,r4
	SUB	r1,r1,r5
	CMP	r1,#96-24
	BGT	errorbox_w
	CMP	r1,#24
	BLT	errorbox_w
	LDR	r1,errorbox_options
	MOV	lr,#4
	ADR	r2,errorbox_ecoords
errorbox_findloop
	LDMIA	r2,{r3-r5}
	CMP	r0,r3
	BLT	errorbox_findnext
	CMP	r0,r5
	BGT	errorbox_findnext
	MOV	r0,lr
errorbox_chosen
	ADR	r1,errorbox_click
	STR	r0,[r1,#4]
	SUB	r0,r0,#4
	STR	r0,errorbox_chose
	SWI	XWimp_SetIconState
	MOV	r0,#19
	SWI	XOS_Byte
	MOV	r0,#15
	MOV	r1,#1
	SWI	XOS_Byte
errorbox_waitnomouse
	SWI	XOS_Mouse
	TEQ	r2,#0
	BNE	errorbox_waitnomouse
	ADR	r1,errorbox_window
	SWI	XWimp_DeleteWindow
;	LDR	r3,=null_handler
;	LDR	r1,old_nullhandler
;	STR	r1,[r3]
;	LDR	r1,old_nulltime
;	STR	r1,[r3,#-4]
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

errorbox_findnext
	ADD	lr,lr,#1
	SUBS	r1,r1,#1
	ADD	r2,r2,#32
	BGT	errorbox_findloop
	B	errorbox_w

	LTORG

errorbox_click
	DCD	0,0
	DCD	1<<21,1<<21

errorbox_window
	DCD	0
errorbox_location
	DCD	0,0,0,0
	DCD	0,0
	DCD	-1,&84000030
	=	7,2,7,1,0,0,0,0
	DCD	0,0,720,w_h
	DCD	&119,0,1,0
errorbox_title
	DCD	0,-1,64
errorbox_icons
	DCD	8
errorbox_iconlist
	DCD	-12,-12,720+12,96				; Change this to 96,96+8 in the Y
	DCD	&07000105,null_string,-1,0

	DCD	32,96+40+mid_y,32+84,96+80+40+mid_y
	DCD	&0000001a
	=	"error",0
	ALIGN
	DCD	0
	DCD	32,w_h-80-40-mid_y,32+84,w_h-40-mid_y
	DCD	&1700011a
errorbox_sprite
	DCD	0,1,1
	DCD	128,96+32,720-16,w_h-32
	DCD	&17000119
;	EXPORT	errorbox_error
errorbox_error
	DCD	errorbox_copyerror,errorbox_lvalid,252

errorbox_ecoords
	DCD	712-iw+4+8,20,712-4-8,96-20			; Increase this one by 8 around
	DCD	&c700013d
	DCD	0,-1,16

	DCD	712-(iw*2)+4+8,20,712-iw-4-8,96-20
	DCD	&0700013d
	DCD	0,-1,16

	DCD	712-(iw*3)+4+8,20,712-(iw*2)-4-8,96-20
	DCD	&0700013d
	DCD	0,-1,16

	DCD	712-(iw*4)+4+8,20,712-(iw*3)-4-8,96-20
	DCD	&0700013d
	DCD	0,-1,16

null_string
	DCD	0
errorbox_lvalid
	=	"l40",0

	EXPORT	ERRORSPRITE
ERRORSPRITE
	DCD	0,0,0,0

	AREA	texts, DATA
	EXPORT	CANCEL
	EXPORT	OK
	EXPORT	CONTINUE
	EXPORT	QUIT
	EXPORT	APPLY
	EXPORT	SAVE

CANCEL	=	"Cancel",0
	ALIGN
	DCD	0,0
CONTINUE
	=	"Continue",0
	ALIGN
	DCD	0
OK	=	"OK",0
	ALIGN
	DCD	0,0,0
QUIT	=	"Quit",0
	ALIGN
	DCD	0,0
APPLY	=	"Apply now",0
	ALIGN
	DCD	0
SAVE	=	"Save",0
	ALIGN
	DCD	0,0,0

	AREA	|____main_nocrash|, CODE, READONLY
	EXPORT	main_nocrash
main_nocrash

;	IMPORT	TrapHandler
	LDR	r3,=temp_regs
	STMIA	r3,{r10,r11,r12,r13,lr}
	ADR	r1,sig
;	LDR	r2,=TrapHandler
;	SUB	r1,r1,r2
;	SUB	r1,r1,#8
;	MOV	r1,r1,LSR#2
;	ORR	r1,r1,#&ea<<24
;	STR	r1,[r2]
	MOV	r0,#6
	MOV	r2,#0
	LDR	r3,=error_data
	SWI	XOS_ChangeEnvironment
	LDR	r0,=old_errordata
	STMIA	r0,{r1-r3}
	ADR	r0,end_error
	IMPORT	atexit
	B	atexit

	LTORG

end_error
	LDR	r0,=old_errordata
	LDMIA	r0,{r1-r3}
	MOV	r0,#6
	SWI	XOS_ChangeEnvironment
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

sig	LDR	r3,=in_error
	LDRB	r2,[r3]
	TEQ	r2,#0
	BNE	bad_exception
	MOV	r2,#1
	STRB	r2,[r3]
	B	exception_deal
bad_exception
	ADR	r2,fatality
	MOV	r1,#17
	SWI	XWimp_ReportError
	SWI	XOS_Exit

fatality
	=	"Error in trap handler",0
	ALIGN

	LTORG

error_handler
	LDR	r0,=error_buffer+4
error_handle
	LDR	r3,=temp_regs
	LDMIA	r3,{r10,r11,r12,r13}
	LDR	r2,=ERRORSPRITE
	ADR	r1,fatal_error
	MOV	r3,#2
	SUB	r13,r13,#8
	LDR	lr,=QUIT
	STR	lr,[r13]
	LDR	lr,=CONTINUE
	STR	lr,[r13,#4]
	BL	new_errorbox
	TEQ	r0,#1
	BEQ	crash_return
	IMPORT	exit
	MOV	r0,#0
	B	exit

crash_return
	LDR	r2,=in_error
	MOV	r3,#0
	STRB	r3,[r2]
	LDR	r3,=temp_regs
 [ arm32
	LDMIA	r3,{r10,r11,r12,r13,pc}
 |
	LDMIA	r3,{r10,r11,r12,r13,pc}^
 ]

fatal_error
	=	"Potentially fatal error" ,0

	AREA	|____error_display|, CODE
	EXPORT	error_display
error_display

; r0 is ^ error
	STMFD	r13!,{lr}
	ADR	r1,ed_titletask
	LDR	r2,=TASKNAME
ed_loop1
	LDRB	r3,[r2],#1
	STRB	r3,[r1],#1
	CMP	r3,#32
	BGE	ed_loop1
	ADR	r1,ed_title
	LDR	r2,=ERRORSPRITE
	LDR	r3,=CONTINUE
	STR	r3,[r13,#-4]!
	MOV	r3,#1
	BL	new_errorbox
 [ arm32
	LDMFD	r13!,{r1,pc}
 |
	LDMFD	r13!,{r1,pc}^
 ]

ed_title
	=	"Message from "
ed_titletask
	%	20
	ALIGN

	AREA	|____errorbox_3d|, CODE, READONLY
	EXPORT	errorbox_3d
errorbox_3d

	LDR	r0,errorbox_iflags
	LDR	r1,=errorbox_iconlist
	LDR	r2,[r1,#32*4+16]
	TEQ	r0,r2
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	ADR	r2,errorbox_boxvalid
	STR	r2,[r1,#24]
	MOV	r2,#96
	STR	r2,[r1,#4]
	ADD	r2,r2,#8
	STR	r2,[r1,#12]
	ADD	r1,r1,#32*4
	ADR	r2,errorbox_defvalid
	STR	r2,[r1,#24]
	LDMIA	r1,{r0,r2,r3}
	SUB	r0,r0,#8
	SUB	r2,r2,#8
	ADD	r3,r3,#8
	STMIA	r1,{r0,r2,r3}
	LDR	r0,[r1,#12]
	ADD	r0,r0,#8
	STR	r0,[r1,#12]
	LDR	r3,errorbox_iflags
	STR	r3,[r1,#16]
	ADD	r1,r1,#32+24
	ADR	r2,errorbox_valid
	STR	r3,[r1,#-8]
	STR	r2,[r1],#32
	STR	r3,[r1,#-8]
	STR	r2,[r1],#32
	STR	r3,[r1,#-8]
	STR	r2,[r1]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

errorbox_iflags
	DCD	&1700013d
errorbox_boxvalid
	=	"r2",0
errorbox_defvalid
	=	"r6,2",0
errorbox_valid
	=	"r5,2",0
	ALIGN

	AREA	|____new_errorboxtxt|, CODE, READONLY
	EXPORT	new_errorboxtxt
new_errorboxtxt

	SUB	r0,r0,#4
	B	new_errorbox


	AREA	|____set_mousewindow|, CODE
	EXPORT	set_mousewindow
set_mousewindow

	STMFD	r13!,{lr}
	SWI	&20100+29
	SWI	&20100
	SWI	&20100
	SWI	&20100
	SWI	&20100
	ADR	lr,mouse_box
	SUB	r2,r2,#1
	SUB	r3,r3,#1
	STRB	r0,[lr,#1]!
	MOV	r0,r0,LSR#8
	STRB	r0,[lr,#1]!
	STRB	r1,[lr,#1]!
	MOV	r1,r1,LSR#8
	STRB	r1,[lr,#1]!
	STRB	r2,[lr,#1]!
	MOV	r2,r2,LSR#8
	STRB	r2,[lr,#1]!
	STRB	r3,[lr,#1]!
	MOV	r3,r3,LSR#8
	STRB	r3,[lr,#1]!
	ADR	r1,mouse_box
	MOV	r0,#21
	SWI	XOS_Word
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

mouse_box
	DCB	1
	DCB	0,0, 0,0, 0,0, 0,0
	ALIGN

	AREA	|VB___Stub$$Dat_|, DATA
	EXPORT	|Stub$$Dat_|
|Stub$$Dat_|

	DCD	0

	AREA	|____qdbug|, CODE, READONLY
	EXPORT	qdbug
qdbug

	SWI	&64b85
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____StartTask|, CODE, READONLY
	EXPORT	StartTask
StartTask

	EXPORT	main_starttask

main_starttask
	SWI	XWimp_StartTask
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_processkey|, CODE, READONLY
	EXPORT	main_processkey
main_processkey

	SWI	Wimp_ProcessKey
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_getosversion|, CODE, READONLY
	EXPORT	main_getosversion
main_getosversion

	MOV	r0,#129
	MOV	r1,#0
	MOV	r2,#255
	SWI	XOS_Byte
	MOV	r0,r1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____check_key|, CODE, READONLY
	EXPORT	check_key
check_key

	ORR	r1,r0,#128
	MOV	r0,#121
	SWI	XOS_Byte
	TEQ	r1,#&ff
	MOVEQ	r0,#1
	MOVNE	r0,#0
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_getrawmouse|, CODE, READONLY
	EXPORT	main_getrawmouse
main_getrawmouse

	STMFD	r13!,{r0-r2,lr}
	SWI	XOS_Mouse
	LDMFD	r13!,{r3}
	TEQ	r3,#0
	STRNE	r0,[r3]
	LDMFD	r13!,{r3}
	TEQ	r3,#0
	STRNE	r1,[r3]
	LDMFD	r13!,{r3}
	TEQ	r3,#0
	STRNE	r2,[r3]
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

	AREA	|____main_getmemorysize|, CODE, READONLY
	EXPORT	main_getmemorysize
main_getmemorysize

	SWI	XOS_ReadMemMapInfo
	MUL	r0,r1,r0
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_strlen|, CODE, READONLY
	EXPORT	main_strlen
main_strlen

	MOV	r2,#0
mstl0	LDRB	r1,[r0],#1
	CMP	r1,#32
	ADDCS	r2,r2,#1
	BCS	mstl0
	MOV	r0,r2
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_strwidth|, CODE, READONLY
	EXPORT	main_strwidth
main_strwidth

	MOV	r1,r0
	MOV	r0,#1
	MOV	r2,#0
	SWI	&600f9
 [ arm32
	MOVVC	pc,lr
 |
	MOVVCS	pc,lr
 ]
	MOV	r0,#0
mstw0	LDRB	r2,[r1],#1
	CMP	r2,#32
	ADDCS	r0,r0,#16
	BCS	mstw0
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_strcpy|, CODE, READONLY
	EXPORT	main_strcpy
main_strcpy

mstc0	LDRB	r2,[r1],#1
	CMP	r2,#32
	STRCSB	r2,[r0],#1
	BCS	mstc0
	MOV	r2,#0
	STRB	r2,[r0],#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_strncpy|, CODE, READONLY
	EXPORT	main_strncpy
main_strncpy

	MOV	r3,r0
mstnc0	SUBS	r3,r3,#1
	BEQ	mstnc1
	LDRB	r2,[r1],#1
	CMP	r2,#32
	STRCSB	r2,[r0],#1
	BCS	mstnc0
mstnc1	MOV	r2,#0
	STRB	r2,[r0],#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_strcmp|, CODE, READONLY
	EXPORT	main_strcmp
main_strcmp

mstcp0	LDRB	r2,[r0],#1
	CMP	r2,#32
	MOVLT	r2,#0
	LDRB	r3,[r1],#1
	CMP	r3,#32
	MOVLT	r3,#1
	TEQ	r2,r3
	BEQ	mstcp0
	TEQ	r2,#0
	TEQEQ	r3,#1
	MOVEQ	r0,#0
	MOVNE	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_stricmp|, CODE, READONLY
	EXPORT	main_stricmp
main_stricmp

	LDRB	r2,[r0],#1
	CMP	r2,#32
	MOVLT	r2,#0
	SUB	r2,r2,#65
	CMP	r2,#26
	ADDCC	r2,r2,#32
	ADD	r2,r2,#65
	LDRB	r3,[r1],#1
	CMP	r3,#32
	MOVLT	r3,#1
	SUB	r3,r3,#65
	CMP	r3,#26
	ADDCC	r3,r3,#32
	ADD	r3,r3,#65
	TEQ	r2,r3
	BEQ	main_stricmp
	TEQ	r2,#0
	TEQEQ	r3,#1
	MOVEQ	r0,#0
	MOVNE	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_vsync|, CODE, READONLY
	EXPORT	main_vsync
main_vsync

	MOV	r0,#19
	SWI	XOS_Byte
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_machinetype|, CODE, READONLY
	EXPORT	main_machinetype
main_machinetype

	STMFD	r13!,{r4,lr}
	MOV	r0,#2
	SWI	XOS_ReadSysInfo
	MOVVS	r0,#0
 [ arm32
	MOVVS	pc,lr
 |
	MOVVSS	pc,lr
 ]
	MOV	r4,r0
	TEQ	r1,#0
	MOVEQ	r0,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	TST	r2,#&ff
	MOVEQ	r0,#0
	MOVNE	r0,#128
	TST	r4,#&ff<<16
	ORRNE	r0,r0,#2
	ORREQ	r0,r0,#1
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____main_transferblock|, CODE, READONLY
	EXPORT	main_transferblock
main_transferblock

; r0 is source task handle
; r1 is source task buffer
; r2 is dest task handle
; r3 is dest task buffer
	MOV	r12,r13
	STMFD	r13!,{r4,lr}
	LDR	r4,[r12]
; r3 is length
	SWI	XWimp_TransferBlock
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____main_getdate|, CODE, READONLY
	EXPORT	main_getdate
main_getdate

	MOV	r1,r0
	MOV	r0,#14
	MOV	r2,#3
	STRB	r2,[r1]
	SWI	XOS_Word
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____main_setpollword|, CODE, READONLY
	EXPORT	main_setpollword
main_setpollword

	LDR	r1,=pollword
	STR	r0,[r1]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	END
